? foo
Index: client.c
===================================================================
RCS file: /var/lib/cvs/dovecot/src/pop3/client.c,v
retrieving revision 1.54
diff -u -r1.54 client.c
--- client.c	23 May 2005 22:40:39 -0000	1.54
+++ client.c	24 May 2005 17:37:15 -0000
@@ -38,6 +38,27 @@
 static void client_input(void *context);
 static int client_output(void *context);
 
+#include <sys/time.h>
+#include <stdio.h>
+#include <unistd.h>
+static void i_debug(const char *format, ...)
+{
+	FILE *f;
+	va_list args;
+	struct timeval tv;
+
+	gettimeofday(&tv, NULL);
+
+	va_start(args, format);
+	t_push();
+	f = fopen(t_strdup_printf("/tmp/dovecot.%d", getpid()), "a+");
+	fprintf(f, "%s.%s PID=%s %s\n", dec2str(tv.tv_sec), dec2str(tv.tv_usec),
+		dec2str(getpid()), t_strdup_vprintf(format, args));
+	fclose(f);
+	t_pop();
+	va_end(args);
+}
+
 static int sync_mailbox(struct mailbox *box, struct mailbox_status *status)
 {
 	struct mailbox_sync_context *ctx;
@@ -275,6 +296,8 @@
 			ret = 1;
 			client->last_output = ioloop_time;
 		} else {
+			i_debug("client_send_line: io=%p, cmd = %p",
+				client->io, client->cmd);
 			ret = 0;
 			if (client->io != NULL) {
 				/* no more input until client has read
@@ -318,6 +341,7 @@
 	struct client *client = context;
 	char *line, *args;
 
+	i_debug("client_input: cmd = %p", client->cmd);
 	if (client->cmd != NULL) {
 		/* we're still processing a command. wait until it's
 		   finished. */
@@ -354,6 +378,7 @@
 		if (client_command_execute(client, line, args)) {
 			client->bad_counter = 0;
 			if (client->cmd != NULL) {
+				i_debug("client_input: command incomplete");
 				o_stream_set_flush_pending(client->output,
 							   TRUE);
 				client->waiting_input = TRUE;
@@ -368,6 +393,7 @@
 
 	if (client->output->closed)
 		client_destroy(client, NULL);
+	i_debug("client_input_end: io=%p, cmd = %p", client->io, client->cmd);
 }
 
 static int client_output(void *context)
@@ -375,6 +401,7 @@
 	struct client *client = context;
 	int ret;
 
+	i_debug("client_output: io=%p, cmd = %p", client->io, client->cmd);
 	if ((ret = o_stream_flush(client->output)) < 0) {
 		client_destroy(client, NULL);
 		return 1;
@@ -398,6 +425,7 @@
 			client_input(client);
 	}
 
+	i_debug("client_output_end: io=%p, cmd = %p", client->io, client->cmd);
 	return client->cmd == NULL;
 }
 
